<?xml version="1.0" encoding="utf-8" ?>
<COLUMN v_align="top">
    <INCLUDE_ONCE file="invisible_button/invisible_toggle.inc"/>
    <INCLUDE_ONCE file="push_toggle/push_toggle.inc"/>
    <INCLUDE_ONCE file="reset_button/reset_button.inc"/>
    <!-- Objects definitions -->
    <DEFINE>
        <CUS_FREQ_GRAPH base_type="CURVE_GRAPH" width="100%" height="100%" sample_rate="2"/>
        <CUS_FILLED_GRAPH base_type="CUS_FREQ_GRAPH" graph_style="bargraph" opacity="$graph_fill_opacity$" antialias="false" sample_rate=".5"/>
        <CUS_MEMORY_CURVE base_type="CURVE" x_min="-1" x_max="0" x_default="0" y_min="-1" y_max="1" y_default="0" persistent="true" />
        <CUS_V_RULER base_type="RULER" font_size="11" text_v_align="center" text_h_align="right" v_margin="7" height="100%" width="18" color="#888888" value_format=".1" content="{value} {unit}" positions_count="11" orientation="vertical" />
        <CUS_H_RULER base_type="RULER" text_h_align="center" h_align="right" h_margin="14" height="13" width="$screen_width$" value_format=".3" content="{value} {unit}" positions_count="11"  font_size="11"/>
        <CUS_GRID base_type="GRID" x_subdiv_count="1" y_subdiv_count="1" width="100%" height="100%"
                subdiv_color="#444444" color="#888888" origin_color="#bbbbbb" x_positions_count="11" y_positions_count="11" />
    </DEFINE>

    <!-- Memory slots buttons template -->
    <TEMPLATE id="TPL_MEMORY_SLOTS" color1="$A_color$" color2="$B_color$" color3="$C_color$" color4="$D_color$">
        <SHORT_ROW>
            <CUS_PUSH_TOGGLE param_id="link_$curve_index$mA.enabled">
                <TEXT text_color="$color1$" value="A"/>
            </CUS_PUSH_TOGGLE>
            <CUS_PUSH_TOGGLE param_id="link_$curve_index$mB.enabled">
                <TEXT text_color="$color2$" value="B"/>
            </CUS_PUSH_TOGGLE>
            <CUS_PUSH_TOGGLE param_id="link_$curve_index$mC.enabled">
                <TEXT text_color="$color3$" value="C"/>
            </CUS_PUSH_TOGGLE>
            <CUS_PUSH_TOGGLE param_id="link_$curve_index$mD.enabled">
                <TEXT text_color="$color4$" value="D" />
            </CUS_PUSH_TOGGLE>
        </SHORT_ROW>
    </TEMPLATE>

    <!-- template for a curve slot -->
    <TEMPLATE id="TPL_CURVE_SLOT">
        <CELL layout_type="row" spacing="3" h_margin="2" h_align="left">
            <PARAM id="show_curve$index$" persistent="true" type="boolean" default="1"/>
            <PARAM_MULTI_LINK from="show_curve$index$;shared.curve$index$_in_use" to="graph$index$.visible" mux_function="min"/>
            <PARAM_MULTI_LINK from="show_curve$index$;shared.curve$index$_in_use;show_filled_curves" to="filled_graph$index$.visible" mux_function="min"/>
            <TPL_CURVE_STRING_CHECK_BOX param_id="show_curve$index$" string_id="shared.curve$index$_name" text_color="$color$index$$" index="$index$" width="74"/>
            <TEXT value="-"/>
            <TPL_MEMORY_SLOTS curve_index="$index$"/>
        </CELL>
    </TEMPLATE>

    <!-- Memories and associated links -->
    <CUS_MEMORY_CURVE id="curve_memA" />
    <CUS_MEMORY_CURVE id="curve_memB" />
    <CUS_MEMORY_CURVE id="curve_memC" />
    <CUS_MEMORY_CURVE id="curve_memD" />

    <TEMPLATE id="TPL_DEFINE_MEM_LINKS">
        <CURVE_LINK from="shared.curve1" to="curve_mem$mem$" id="link_1m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve2" to="curve_mem$mem$" id="link_2m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve3" to="curve_mem$mem$" id="link_3m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve4" to="curve_mem$mem$" id="link_4m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve5" to="curve_mem$mem$" id="link_5m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve6" to="curve_mem$mem$" id="link_6m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve7" to="curve_mem$mem$" id="link_7m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve8" to="curve_mem$mem$" id="link_8m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve9" to="curve_mem$mem$" id="link_9m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve10" to="curve_mem$mem$" id="link_10m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve11" to="curve_mem$mem$" id="link_11m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve12" to="curve_mem$mem$" id="link_12m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve13" to="curve_mem$mem$" id="link_13m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve14" to="curve_mem$mem$" id="link_14m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve15" to="curve_mem$mem$" id="link_15m$mem$" enabled="false" />
        <CURVE_LINK from="shared.curve16" to="curve_mem$mem$" id="link_16m$mem$" enabled="false" />
    </TEMPLATE>

    <TPL_DEFINE_MEM_LINKS mem="A" />
    <TPL_DEFINE_MEM_LINKS mem="B" />
    <TPL_DEFINE_MEM_LINKS mem="C" />
    <TPL_DEFINE_MEM_LINKS mem="D" />

    <PERSISTENT_PARAMS param_ids="graphMemA.visible;graphMemB.visible;graphMemC.visible;graphMemD.visible"/>

    <!-- show / hide links-->
    <PARAM id="one" default="1" type="boolean"/>
    <PARAM id="zero" default="0" type="boolean"/>
    <VARIABLE id="show_curves_list" value="show_curve1;show_curve2;show_curve3;show_curve4;show_curve5;show_curve6;show_curve7;show_curve8;show_curve9;show_curve10;show_curve11;show_curve12;show_curve13;show_curve14;show_curve15;show_curve16"/>
    <PARAM_MULTI_LINK from="zero" to="$show_curves_list$" id="hide_curves_link" enabled="false"/>
    <PARAM_MULTI_LINK from="one" to="$show_curves_list$" id="show_curves_link" enabled="false"/>

    <!-- Setting to show filled curves -->
    <PARAM id="show_filled_curves" type="boolean" persistent="true"/>
    <PARAM id="anti_alias_curves" type="boolean" persistent="true" default="1"/>
    <PARAM_MULTI_LINK from="anti_alias_curves" to="graph1.anti_alias;graph2.anti_alias;graph3.anti_alias;graph4.anti_alias;graph5.anti_alias;graph6.anti_alias;graph7.anti_alias;graph8.anti_alias;graph9.anti_alias;graph10.anti_alias;graph11.anti_alias;graph12.anti_alias;graph13.anti_alias;graph14.anti_alias;graph15.anti_alias;graph16.anti_alias"/>

    <!-- x/y mouse parameters -->
    <PARAM id="x_value" min="-1" max="0" default="0" name="x" unit="s"/>
    <PARAM id="y_value" min="-1" max="1" default="0" name="y" />
    <!-- link for the drag or measure stuff -->
    <PARAM_LINK from="mouse_measure" to="coords.visible" />
    <PARAM_LINK from="mouse_measure" to="position_cell.visible"/>

    <ROW>
        <COLUMN v_align="top">
            <CELL height="8"/>
            <COLUMN v_margin="-5">
                <CELL height="5" />
                <LAYER_STACK width="500">
                    <!-- show filled curves + antialias-->
                    <ROW h_align="center" spacing="10">
                        <TPL_CURVE_CHECK_BOX color="#dddddd" param_id="show_filled_curves" text="Show filled curves" />
                        <TPL_CURVE_CHECK_BOX color="#dddddd" param_id="anti_alias_curves" text="Antialias"/>

                        <!-- values display -->
                        <IMAGE_GROUP_BOX layout_type="row" id="position_cell" h_margin="5">
                            <TEXT value="Position: " />
                            <TEXT value="(" height="10" />
                            <PARAM_TEXT param_id="x_value" width="50" height="10" content="{value} {unit}" value_format=".3"
                              text_color="#dddddd" />
                            <TEXT value="|" height="10" />
                            <PARAM_TEXT param_id="y_value" width="40" height="10" content="{value} {unit}" value_format=".2"
                              text_color="#dddddd" />
                            <TEXT value=")" height="10" />
                        </IMAGE_GROUP_BOX>
                    </ROW>
                    <!-- Mouse display mode buttons-->
                    <CUS_VBLACK_BOX layout_type="column" width="55" h_align="right">
                        <ROW spacing="5">
                            <CUS_HAND_BUTTON param_id="mouse_drag">
                                <TOOLTIP text="Drag Mode" />
                            </CUS_HAND_BUTTON>
                            <CUS_CROSS_BUTTON param_id="mouse_measure">
                                <TOOLTIP text="Measure Mode" />
                            </CUS_CROSS_BUTTON>
                        </ROW>
                    </CUS_VBLACK_BOX>
                </LAYER_STACK>
            </COLUMN>
            <LAYER_STACK>
                <TABLE h_margin="3" font_size="11">
                    <TABLE_ROW>
                        <!-- Y scale -->
                        <CUS_V_RULER param_info_id="shared.curve1.y_info" id="y_scale" />
                        <!-- Graphs -->
                        <LAYER_STACK height="$screen_height$" width="$screen_width$" v_margin="7" h_margin="14">
                            <CUS_GRID x_param_info_id="shared.curve1.x_info" y_param_info_id="shared.curve1.y_info" id="grid" />

                            <!-- Real time bargraphs -->
                            <CUS_FILLED_GRAPH id="filled_graph1" color="$color1$" curve_id="shared.curve1" />
                            <CUS_FILLED_GRAPH id="filled_graph2" color="$color2$" curve_id="shared.curve2" />
                            <CUS_FILLED_GRAPH id="filled_graph3" color="$color3$" curve_id="shared.curve3" />
                            <CUS_FILLED_GRAPH id="filled_graph4" color="$color4$" curve_id="shared.curve4" />
                            <CUS_FILLED_GRAPH id="filled_graph5" color="$color5$" curve_id="shared.curve5" />
                            <CUS_FILLED_GRAPH id="filled_graph6" color="$color6$" curve_id="shared.curve6" />
                            <CUS_FILLED_GRAPH id="filled_graph7" color="$color7$" curve_id="shared.curve7" />
                            <CUS_FILLED_GRAPH id="filled_graph8" color="$color8$" curve_id="shared.curve8" />
                            <CUS_FILLED_GRAPH id="filled_graph9" color="$color9$" curve_id="shared.curve9" />
                            <CUS_FILLED_GRAPH id="filled_graph10" color="$color10$" curve_id="shared.curve10" />
                            <CUS_FILLED_GRAPH id="filled_graph11" color="$color11$" curve_id="shared.curve11" />
                            <CUS_FILLED_GRAPH id="filled_graph12" color="$color12$" curve_id="shared.curve12" />
                            <CUS_FILLED_GRAPH id="filled_graph13" color="$color13$" curve_id="shared.curve13" />
                            <CUS_FILLED_GRAPH id="filled_graph14" color="$color14$" curve_id="shared.curve14" />
                            <CUS_FILLED_GRAPH id="filled_graph15" color="$color15$" curve_id="shared.curve15" />
                            <CUS_FILLED_GRAPH id="filled_graph16" color="$color16$" curve_id="shared.curve16" />

                            <!-- Real time graphs -->
                            <CUS_FREQ_GRAPH id="graph1" color="$color1$" curve_id="shared.curve1" />
                            <CUS_FREQ_GRAPH id="graph2" color="$color2$" curve_id="shared.curve2" />
                            <CUS_FREQ_GRAPH id="graph3" color="$color3$" curve_id="shared.curve3" />
                            <CUS_FREQ_GRAPH id="graph4" color="$color4$" curve_id="shared.curve4" />
                            <CUS_FREQ_GRAPH id="graph5" color="$color5$" curve_id="shared.curve5" />
                            <CUS_FREQ_GRAPH id="graph6" color="$color6$" curve_id="shared.curve6" />
                            <CUS_FREQ_GRAPH id="graph7" color="$color7$" curve_id="shared.curve7" />
                            <CUS_FREQ_GRAPH id="graph8" color="$color8$" curve_id="shared.curve8" />
                            <CUS_FREQ_GRAPH id="graph9" color="$color9$" curve_id="shared.curve9" />
                            <CUS_FREQ_GRAPH id="graph10" color="$color10$" curve_id="shared.curve10" />
                            <CUS_FREQ_GRAPH id="graph11" color="$color11$" curve_id="shared.curve11" />
                            <CUS_FREQ_GRAPH id="graph12" color="$color12$" curve_id="shared.curve12" />
                            <CUS_FREQ_GRAPH id="graph13" color="$color13$" curve_id="shared.curve13" />
                            <CUS_FREQ_GRAPH id="graph14" color="$color14$" curve_id="shared.curve14" />
                            <CUS_FREQ_GRAPH id="graph15" color="$color15$" curve_id="shared.curve15" />
                            <CUS_FREQ_GRAPH id="graph16" color="$color16$" curve_id="shared.curve16" />

                            <!-- Memory graphs -->
                            <CUS_FREQ_GRAPH id="graphMemA" color="$A_color$" curve_id="curve_memA" visible="true" />
                            <CUS_FREQ_GRAPH id="graphMemB" color="$B_color$" curve_id="curve_memB" visible="true" />
                            <CUS_FREQ_GRAPH id="graphMemC" color="$C_color$" curve_id="curve_memC" visible="true" />
                            <CUS_FREQ_GRAPH id="graphMemD" color="$D_color$" curve_id="curve_memD" visible="true" />

                            <!-- zoom scratch pad -->
                            <XYZ_PARAM_SCRATCH_PAD height="100%" width="100%" x_param_id="graph_x_offset" y_param_id="graph_y_offset"
                              x_reverse="true" y_reverse="true" id="scratchpad" cursor="system::open_hand" />
                            <!-- The controller that let you see the xY coordinates values -->
                            <XY_ZOOM_SELECT_PAD id="coords" height="100%" width="100%" x_param_id="x_value" y_param_id="y_value"	x_zoom_param_id="graph_x_zoom" y_zoom_param_id="graph_y_zoom" x_offset_param_id="graph_x_offset" y_offset_param_id="graph_y_offset" cursor="system::cross" color="#ffffff"/>
                            <!-- zoom sliders -->
                            <ROW h_position="9" v_position="2">
                                <COLUMN v_align="top">
                                    <IMAGE image="plus.bmp"/>
                                    <CUS_V_SLIDER_SMALL param_id="graph_y_zoom" reverse="true" positions_count="9">
                                        <CUS_TOOLTIP param_id="graph_y_zoom" content="{name}: {value}"/>
                                    </CUS_V_SLIDER_SMALL>
                                </COLUMN>
                                <CUS_H_SLIDER_SMALL param_id="graph_x_zoom" v_align="top" positions_count="100">
                                    <CUS_TOOLTIP param_id="graph_x_zoom" content="{name}: {value}"/>
                                </CUS_H_SLIDER_SMALL>
                            </ROW>
                        </LAYER_STACK>
                        <!-- slider -->
                    </TABLE_ROW>
                    <TABLE_ROW>
                        <CELL />
                        <CUS_H_RULER param_info_id="dsp.output_curve0.x_info" id="x_scale"/>
                        <CELL />
                    </TABLE_ROW>
                </TABLE>
            </LAYER_STACK>
             <!-- Modes -->
            <ROW spacing="30" v_margin="4">
                <CUS_BLACK_BOX layout_type="layer_stack" v_margin="1">
                    <PARAM_TEXT param_id="dsp.input1" width="100"/>
                    <CUS_INVISIBLE_BUTTON param_id="dsp.input1" width="100%" height="100%"/>
                </CUS_BLACK_BOX>
                <CUS_RESET_BUTTON param_id="shared.trigger">
                    <TOOLTIP text="Synchronize Instances"/>
                </CUS_RESET_BUTTON>
                <CUS_BLACK_BOX layout_type="layer_stack" v_margin="1">
                    <PARAM_TEXT param_id="model.flow_mode" width="100" content="{text_value} Mode"/>
                    <CUS_INVISIBLE_BUTTON param_id="model.flow_mode" width="100%" height="100%"/>
                </CUS_BLACK_BOX>
            </ROW>
        </COLUMN>
        <!-- Show/Hide buttons -->
        <DEFINE>
            <SHORT_ROW base_type="ROW" spacing="4"/>
        </DEFINE>

        <COLUMN spacing="3" v_margin="7" h_margin="2" v_align="top">
            <TPL_TITLE text="Curves"/>
            <CUS_VBLACK_BOX layout_type="column" spacing="2" margin="2">
                <ROW spacing="7">
                    <TEXT value="Curves" width="89"/>
                    <TEXT value="-"/>
                    <TEXT value="Store to"/>
                </ROW>
                <TPL_CURVE_SLOT index="1"/>
                <TPL_CURVE_SLOT index="2"/>
                <TPL_CURVE_SLOT index="3"/>
                <TPL_CURVE_SLOT index="4"/>
                <TPL_CURVE_SLOT index="5"/>
                <TPL_CURVE_SLOT index="6"/>
                <TPL_CURVE_SLOT index="7"/>
                <TPL_CURVE_SLOT index="8"/>
                <TPL_CURVE_SLOT index="9"/>
                <TPL_CURVE_SLOT index="10"/>
                <TPL_CURVE_SLOT index="11"/>
                <TPL_CURVE_SLOT index="12"/>
                <TPL_CURVE_SLOT index="13"/>
                <TPL_CURVE_SLOT index="14"/>
                <TPL_CURVE_SLOT index="15"/>
                <TPL_CURVE_SLOT index="16"/>
                <ROW spacing="5" text_decoration="underline">
                    <TEXT value="show all">
                        <CUS_INVISIBLE_TOGGLE param_id="show_curves_link.enabled"/>
                    </TEXT>
                    <TEXT value="/" text_decoration="none"/>
                    <TEXT value="hide all">
                        <CUS_INVISIBLE_TOGGLE param_id="hide_curves_link.enabled"/>
                    </TEXT>
                </ROW>
            </CUS_VBLACK_BOX>
            <CUS_VBLACK_BOX layout_type="column" width="100%">
                <TEXT value="Memory Slots" />
                <SHORT_ROW>
                    <TPL_CURVE_CHECK_BOX param_id="graphMemA.visible" text_color="$A_color$" text="A"/>
                    <CELL/>
                    <TPL_CURVE_CHECK_BOX param_id="graphMemB.visible" text_color="$B_color$" text="B"/>
                    <CELL/>
                    <TPL_CURVE_CHECK_BOX param_id="graphMemC.visible" text_color="$C_color$" text="C"/>
                    <CELL/>
                    <TPL_CURVE_CHECK_BOX param_id="graphMemD.visible" text_color="$D_color$" text="D"/>
                </SHORT_ROW>
            </CUS_VBLACK_BOX>
        </COLUMN>
    </ROW>

    <!-- Zoom parameters and links -->
    <PARAM_LINK from="grid.x_extra_pixels" to="scratchpad.x_pixel_range" />
    <PARAM_LINK from="grid.y_extra_pixels" to="scratchpad.y_pixel_range" />

    <!-- X zoom -->
    <PARAM id="graph_x_zoom" min="1" max="100" default="1" name="Time zoom" persistent="true" />
    <PARAM_MULTI_LINK from="graph_x_zoom" to="graphMemA.x_zoom;graphMemB.x_zoom;graphMemC.x_zoom;graphMemD.x_zoom" />
    <PARAM_MULTI_LINK from="graph_x_zoom" to="x_scale.zoom;grid.x_zoom;coords.x_zoom"/>

    <!-- X offset -->
    <PARAM id="graph_x_offset" min="0" max="1" default="1" name="X offset" persistent="true" />
    <PARAM_MULTI_LINK from="graph_x_offset" to="graphMemA.x_offset;graphMemB.x_offset;graphMemC.x_offset;graphMemD.x_offset" />
    <PARAM_MULTI_LINK from="graph_x_offset" to="x_scale.offset;grid.x_offset;coords.x_offset" />

    <!-- Y Zoom -->
    <PARAM id="graph_y_zoom" min="1" max="5" default="1" name="Value zoom" persistent="true" />
    <PARAM_MULTI_LINK from="graph_y_zoom" to="graphMemA.y_zoom;graphMemB.y_zoom;graphMemC.y_zoom;graphMemD.y_zoom" />
    <PARAM_MULTI_LINK from="graph_y_zoom" to="y_scale.zoom;grid.y_zoom;coords.y_zoom" />

    <!-- Y Offset -->
    <PARAM id="graph_y_offset" min="0" max="1" default=".5" name="Y offset" persistent="true" />
    <PARAM_MULTI_LINK from="graph_y_offset" to="graphMemA.y_offset;graphMemB.y_offset;graphMemC.y_offset;graphMemD.y_offset" />
    <PARAM_MULTI_LINK from="graph_y_offset" to="y_scale.offset;grid.y_offset;coords.y_offset" />

    <!-- curves -->
    <TEMPLATE id="TPL_CURVE_ZOOM_LINKS">
        <PARAM_MULTI_LINK from="graph_x_zoom" to="graph$index$.x_zoom;filled_graph$index$.x_zoom" />
        <PARAM_MULTI_LINK from="graph_y_zoom" to="graph$index$.y_zoom;filled_graph$index$.y_zoom"/>
        <PARAM_MULTI_LINK from="graph_x_offset" to="graph$index$.x_offset;filled_graph$index$.x_offset"/>
        <PARAM_MULTI_LINK from="graph_y_offset" to="graph$index$.y_offset;filled_graph$index$.y_offset"/>
    </TEMPLATE>

    <TPL_CURVE_ZOOM_LINKS index="1"/>
    <TPL_CURVE_ZOOM_LINKS index="2"/>
    <TPL_CURVE_ZOOM_LINKS index="3"/>
    <TPL_CURVE_ZOOM_LINKS index="4"/>
    <TPL_CURVE_ZOOM_LINKS index="5"/>
    <TPL_CURVE_ZOOM_LINKS index="6"/>
    <TPL_CURVE_ZOOM_LINKS index="7"/>
    <TPL_CURVE_ZOOM_LINKS index="8"/>
    <TPL_CURVE_ZOOM_LINKS index="9"/>
    <TPL_CURVE_ZOOM_LINKS index="10"/>
    <TPL_CURVE_ZOOM_LINKS index="11"/>
    <TPL_CURVE_ZOOM_LINKS index="12"/>
    <TPL_CURVE_ZOOM_LINKS index="13"/>
    <TPL_CURVE_ZOOM_LINKS index="14"/>
    <TPL_CURVE_ZOOM_LINKS index="15"/>
    <TPL_CURVE_ZOOM_LINKS index="16"/>
</COLUMN>